// Generated by CoffeeScript 1.6.3
(function() {
  var Destroyer, fs, fsu, path;

  fs = require('fs');

  path = require('path');

  fsu = require("fs-util");

  module.exports = Destroyer = (function() {
    function Destroyer(the, cli, type, name, rf, repl) {
      var error_msg;
      this.the = the;
      this.cli = cli;
      this.repl = repl;
      if (!this.the.is_theoricus_app()) {
        return;
      }
      if (this.cli === null) {
        this.cli = {
          argv: {
            _: [name],
            destroy: type,
            rf: rf
          }
        };
      }
      type = this.cli.argv.destroy;
      name = this.cli.argv._[0];
      this.SRC = "" + this.the.pwd + "/src";
      this.APP_FOLDER = "" + this.SRC + "/app";
      this.TEMPLATES_FOLDER = "" + this.SRC + "/templates";
      this.STYLES_FOLDER = "" + this.SRC + "/styles";
      if (this[type] == null) {
        error_msg = "Valid options: controller, model, view, mvc.";
        (this.repl || console).error(error_msg);
      }
      this[type](name);
    }

    Destroyer.prototype.mvc = function(name) {
      this.model(name.singularize());
      this.view("" + name + "/index");
      return this.controller(name);
    };

    Destroyer.prototype.model = function(name) {
      return this.rm("" + this.APP_FOLDER + "/models/" + name + ".coffee");
    };

    Destroyer.prototype.view = function(path) {
      var error_msg, folder, name, parts;
      folder = (parts = path.split('/'))[0];
      name = parts[1];
      if (!((name != null) || this.cli.argv.rf)) {
        error_msg = "Views should be removed with path-style notation.\n\n\ti.e.:\n\t\t theoricus rm view person/index\n\t\t theoricus rm view user/list\n";
        return (this.repl || console).error(error_msg);
      }
      if (this.cli.argv.rf) {
        this.rm("" + this.APP_FOLDER + "/views/" + folder);
        this.rm("" + this.STYLES_FOLDER + "/" + folder);
        return this.rm("" + this.TEMPLATES_FOLDER + "/" + folder);
      } else {
        this.rm("" + this.APP_FOLDER + "/views/" + folder + "/" + name + ".coffee");
        this.rm("" + this.TEMPLATES_FOLDER + "/" + folder + "/" + name + ".jade");
        return this.rm("" + this.STYLES_FOLDER + "/" + folder + "/" + name + ".styl");
      }
    };

    Destroyer.prototype.controller = function(name, args, mvc) {
      if (mvc == null) {
        mvc = false;
      }
      return this.rm("" + this.APP_FOLDER + "/controllers/" + name + ".coffee");
    };

    Destroyer.prototype.rm = function(filepath) {
      var err, relative;
      relative = filepath.replace(this.the.app_root + '/', '');
      if (fs.existsSync(filepath)) {
        try {
          if (fs.lstatSync(filepath).isDirectory()) {
            if (this.cli.argv.rf) {
              fsu.rm_rf(filepath);
            } else {
              fs.rmDirSync(filepath);
            }
          } else {
            fs.unlinkSync(filepath);
          }
        } catch (_error) {
          err = _error;
          throw new Error(err);
        }
        if (!this.repl) {
          return console.log(("" + 'Removed'.bold + " " + relative).red);
        }
      } else {
        return (this.repl || console).error(("" + 'Not found'.bold + " " + relative).yellow);
      }
    };

    return Destroyer;

  })();

}).call(this);

/*
//@ sourceMappingURL=destroyer.map
*/
